package core.entities.timemanager;

import core.entities.User;

import javax.persistence.*;
import javax.validation.constraints.NotBlank;
import java.util.Set;

@Entity
@Table(name= "taskgroups")
public class Taskgroup {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private long taskgroupID;

    @NotBlank
    @Column(name = "name", length = 255)
    private String taskgroupName;

    @OneToOne
    @JoinColumn(name = "taskgroupuser", nullable = false)
    private User user;

    @OneToMany(mappedBy = "parent", cascade = CascadeType.ALL, fetch = FetchType.EAGER)
    private Set<Taskgroup> children;

    @ManyToOne
    @JoinColumn(name = "parent_id")
    private Taskgroup parent;

    @OneToMany(mappedBy = "taskgroup", cascade = CascadeType.ALL, fetch = FetchType.EAGER)
    private Set<Task> tasks;

    public Taskgroup(String taskgroupName, User user) {
        this.taskgroupName = taskgroupName;
        this.user = user;
    }

    public Taskgroup() {
    }

    public long getTaskgroupID() {
        return taskgroupID;
    }

    public void setTaskgroupID(long taskgroupID) {
        this.taskgroupID = taskgroupID;
    }

    public String getTaskgroupName() {
        return taskgroupName;
    }

    public void setTaskgroupName(String taskgroupName) {
        this.taskgroupName = taskgroupName;
    }

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }

    public Set<Taskgroup> getChildren() {
        return children;
    }

    public void setChildren(Set<Taskgroup> children) {
        this.children = children;
    }

    public Taskgroup getParent() {
        return parent;
    }

    public void setParent(Taskgroup parent) {
        this.parent = parent;
    }

    public Set<Task> getTasks() {
        return tasks;
    }

    public void setTasks(Set<Task> tasks) {
        this.tasks = tasks;
    }
}
